// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Name   : client_SetRxLnbLoFrequency()
// Purpose: Called when user selects a receive Lnb LO frequency.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetRxLnbLoFrequency(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxLnbLoFrequencyInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx LNB Lo Frequency"))
            {
               var aFrequency = parseInt((parseFloat(anElement.value)) * 1000000);
               anElement.value = FormatNumber((aFrequency / 1000000), 6);
               aFrequency += 0.000001;
               serverRcvLnbIntf.SetRxLnbLoFrequency(aFrequency);
               Focus_Iframe();
            }
         }
      }
   }
};

// ************************************************************************************
// Name   : client_SetRxLnbOscSideBand()
// Purpose: Called when user selects a receive Lnb Osc side from the RxLnbOscBand combo box.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetRxLnbOscSideBand()
{
   var anElement = Get_Iframe_Element( 'RxLnbOscSideBandSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Rx LNB Oscillator Side Band"))
      {
         serverRcvLnbIntf.SetRxLnbOscSideBand(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetRxLnbReferenceEnable()
// Purpose: Called when user selects a receive Lnb Osc side from the RxLnbReferenceEnable combo box.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetRxLnbReferenceEnable()
{
   var anElement = Get_Iframe_Element( 'RxLnbReferenceEnableSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Rx LNB Reference Enable"))
      {
         serverRcvLnbIntf.SetRxLnbReferenceEnable(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetRxLnbSupplyVoltageEnable()
// Purpose: Called when user selects a receive Lnb Osc side from the RxLnbSupplyVoltageEnable combo box.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetRxLnbSupplyVoltageEnable()
{
   var anElement = Get_Iframe_Element( 'RxLnbSupplyVoltageEnableSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Rx LNB Supply Voltage Enable"))
      {
         serverRcvLnbIntf.SetRxLnbSupplyVoltageEnable(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetRxLnbLowVoltAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxLnbLowVoltAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx LNB Low Volt Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 1);
               aThreshold += 0.000001;
               serverRcvLnbIntf.SetRxLnbLowVoltAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetRxLnbLowAmpAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxLnbLowAmpAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx LNB Low Amp Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 2);
               aThreshold += 0.000001;
               serverRcvLnbIntf.SetRxLnbLowAmpAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetRxLnbHighVoltAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxLnbHighVoltAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx LNB High Volt Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 1);
               aThreshold += 0.000001;
               serverRcvLnbIntf.SetRxLnbHighVoltAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetRxLnbHighAmpAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxLnbHighAmpAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx LNB High Amp Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 2);
               aThreshold += 0.000001;
               serverRcvLnbIntf.SetRxLnbHighAmpAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

// ************************************************************************************
// Name   : client_SetRxLnbSupplyVoltageSelect()
// Purpose: Called when user selects a receive Lnb supply voltage select.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetRxLnbSupplyVoltageSelect()
{
   var anElement = Get_Iframe_Element( 'RxLnbSupplyVoltageSelectSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Rx LNB Supply Voltage Select"))
      {
         serverRcvLnbIntf.SetRxLnbSupplyVoltageSelect(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetRxLnbStatusUpdate()
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetRxLnbStatusUpdate()
{
   serverRcvLnbIntf.SetRxLnbSelectContentUpdate();
   serverRcvLnbIntf.SetRxLnbStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateRcvLnbLoFrequencyStatus(anLoFrequency)
{
   var anElement = Get_Iframe_Element( 'RxLnbLoFrequencyInput' ) ;
   if ( anElement )	        // Set receive Lo frequency
      anElement.value = FormatNumber((anLoFrequency / 1000000), 6);;
}

function asyncUpdateRcvLnbOscSideBandStatus(anOscSideBand)
{
   var anElement = Get_Iframe_Element( 'RxLnbOscSideBandSelect' ) ;
   if ( anElement )	            // Set receive Lnb Osc side band
      anElement.value = anOscSideBand;
}

function asyncUpdateRcvLnbReferenceEnableStatus(aReferenceEnable)
{
   var anElement = Get_Iframe_Element( 'RxLnbReferenceEnableSelect' ) ;
   if ( anElement )	              // Set receive Lnb reference enable
      anElement.value = aReferenceEnable;
}

function asyncUpdateRcvLnbSupplyVoltageEnableStatus(aSupplyVoltageEnable)
{
   var anElement = Get_Iframe_Element( 'RxLnbSupplyVoltageEnableSelect' ) ;
   if ( anElement )	                 // Set receive Lnb supply voltage enable
      anElement.value = aSupplyVoltageEnable;
}

function asyncUpdateRcvLnbLowVoltAlarmThresholdStatus(aLowVoltAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'RxLnbLowVoltAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aLowVoltAlarmThreshold, 1);
}

function asyncUpdateRcvLnbLowAmpAlarmThresholdStatus(aLowAmpAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'RxLnbLowAmpAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aLowAmpAlarmThreshold, 2);
}

function asyncUpdateRcvLnbHighVoltAlarmThresholdStatus(aHighVoltAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'RxLnbHighVoltAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aHighVoltAlarmThreshold, 1);
}

function asyncUpdateRcvLnbHighAmpAlarmThresholdStatus(aHighAmpAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'RxLnbHighAmpAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aHighAmpAlarmThreshold, 2);
}

function asyncUpdateRcvLnbSupplyVoltageSelectStatus(aSupplyVoltageSelect)
{
   var anElement = Get_Iframe_Element( 'RxLnbSupplyVoltageSelectSelect' ) ;
   if ( anElement )	              // Set receive Lnb supply voltage select
      anElement.value = aSupplyVoltageSelect;
}

// ****************************************************************** 
// * Functions to update the select content.
// ******************************************************************

function asyncUpdateRcvLnbOscSideBandSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'RxLnbOscSideBandSelect', aSelectContent );
}

function asyncUpdateRcvLnbReferenceEnableSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'RxLnbReferenceEnableSelect', aSelectContent );
}

function asyncUpdateRcvLnbSupplyVoltageEnableSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'RxLnbSupplyVoltageEnableSelect', aSelectContent );
}

function asyncUpdateRcvLnbSupplyVoltageSelectSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'RxLnbSupplyVoltageSelectSelect', aSelectContent );
}

