// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

function client_SetTxBucLoFrequency(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucLoFrequencyInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsBandwidthChangeConfirmed("Tx BUC Lo Frequency"))
            {
               var aFrequency = parseInt((parseFloat(anElement.value)) * 1000000);
               anElement.value = FormatNumber((aFrequency / 1000000), 6);
               aFrequency += 0.000001;
               serverXmitBucIntf.SetTxBucLoFrequency(aFrequency);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucCarrierDelay(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucCarrierDelayInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Tx BUC Carrier Delay"))
            {
               serverXmitBucIntf.SetTxBucCarrierDelay(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucLowVoltAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucLowVoltAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Tx BUC Low Volt Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 1);
               aThreshold += 0.000001;
               serverXmitBucIntf.SetTxBucLowVoltAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucLowAmpAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucLowAmpAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Tx BUC Low Amp Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 2);
               aThreshold += 0.000001;
               serverXmitBucIntf.SetTxBucLowAmpAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucHighVoltAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucHighVoltAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Tx BUC High Volt Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 1);
               aThreshold += 0.000001;
               serverXmitBucIntf.SetTxBucHighVoltAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucHighAmpAlarmThreshold(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucHighAmpAlarmThresholdInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Tx BUC High Amp Alarm Threshold"))
            {
               var aThreshold = parseFloat(anElement.value);
               anElement.value = FormatNumber(aThreshold, 2);
               aThreshold += 0.000001;
               serverXmitBucIntf.SetTxBucHighAmpAlarmThreshold(aThreshold);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucOscSideBand()
{
   var anElement = Get_Iframe_Element( 'TxBucOscSideBandSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx BUC Oscillator Side Band"))
      {
         serverXmitBucIntf.SetTxBucOscSideBand(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetTxBucReferenceEnable()
{
   var anElement = Get_Iframe_Element( 'TxBucReferenceEnableSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx BUC Reference Enable"))
      {
         serverXmitBucIntf.SetTxBucReferenceEnable(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetTxBucSupplyVoltageEnable()
{
   var anElement = Get_Iframe_Element( 'TxBucSupplyVoltageEnableSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx BUC Supply Voltage Enable"))
      {
         serverXmitBucIntf.SetTxBucSupplyVoltageEnable(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetTxBucFskComms()
{
   var anElement = Get_Iframe_Element( 'TxBucFskCommsSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx BUC FSK Comms"))
      {
         serverXmitBucIntf.SetTxBucFskComms(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
   setTimeout("RefreshIframe();", 250);
};

function client_SetTxBucOutputEnable()
{
   var anElement = Get_Iframe_Element( 'TxBucOutputEnableSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx BUC Output Enable"))
      {
         serverXmitBucIntf.SetTxBucOutputEnable(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetTxBucAddress(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucAddressInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Tx BUC Address"))
            {
               serverXmitBucIntf.SetTxBucAddress(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetTxBucFskTest()
{
   var anElement = Get_Iframe_Element( 'TxBucFskTestSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx BUC FSK Test"))
      {
         serverXmitBucIntf.SetTxBucFskTest(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetTxBucFskPassThroughCommand(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxBucFskPassThroughCommandInput' ) ;
      if ( anElement )
      {
         if (IsNotEmpty(anElement))
         {
            if (IsChangeConfirmed("Tx BUC FSK PassThrough Command"))
            {
               serverXmitBucIntf.SetTxBucFskPassThroughCommand(anElement.value);
               setTimeout("SetTxBucFskExecutePassThroughCommand();", 250);
               Focus_Iframe();
            }
         }
      }
   }
};

function SetTxBucFskExecutePassThroughCommand()
{
   serverXmitBucIntf.SetTxBucFskExecutePassThroughCommand();
}

// ************************************************************************************
// Name   : client_SetTxBucStatusUpdate()
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetTxBucStatusUpdate()
{
   serverXmitBucIntf.SetTxBucSelectContentUpdate();
   serverXmitBucIntf.SetTxBucStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateXmitBucLoFrequencyStatus(anLoFrequency)
{
   var anElement = Get_Iframe_Element( 'TxBucLoFrequencyInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber((anLoFrequency / 1000000), 6);;
}

function asyncUpdateXmitBucCarrierDelayStatus(aCarrierDelay)
{
   var anElement = Get_Iframe_Element( 'TxBucCarrierDelayInput' ) ;
   if ( anElement )
      anElement.value = aCarrierDelay;
}

function asyncUpdateXmitBucLowVoltAlarmThresholdStatus(aLowVoltAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'TxBucLowVoltAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aLowVoltAlarmThreshold, 1);
}

function asyncUpdateXmitBucLowAmpAlarmThresholdStatus(aLowAmpAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'TxBucLowAmpAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aLowAmpAlarmThreshold, 2);
}

function asyncUpdateXmitBucHighVoltAlarmThresholdStatus(aHighVoltAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'TxBucHighVoltAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aHighVoltAlarmThreshold, 1);
}

function asyncUpdateXmitBucHighAmpAlarmThresholdStatus(aHighAmpAlarmThreshold)
{
   var anElement = Get_Iframe_Element( 'TxBucHighAmpAlarmThresholdInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(aHighAmpAlarmThreshold, 2);
}

function asyncUpdateXmitBucOscSideBandStatus(anOscSideBand)
{
   var anElement = Get_Iframe_Element( 'TxBucOscSideBandSelect' ) ;
   if ( anElement )
      anElement.value = anOscSideBand;
}

function asyncUpdateXmitBucReferenceEnableStatus(aReferenceEnable)
{
   var anElement = Get_Iframe_Element( 'TxBucReferenceEnableSelect' ) ;
   if ( anElement )
      anElement.value = aReferenceEnable;
}

function asyncUpdateXmitBucSupplyVoltageEnableStatus(aSupplyVoltageEnable)
{
   var anElement = Get_Iframe_Element( 'TxBucSupplyVoltageEnableSelect' ) ;
   if ( anElement )
      anElement.value = aSupplyVoltageEnable;
}

function asyncUpdateXmitBucFskCommsStatus(anFskComms)
{
   var anElement = Get_Iframe_Element( 'TxBucFskCommsSelect' ) ;
   if ( anElement )
   {
      anElement.value = anFskComms;
      anElement = Get_Iframe_Element( 'TxBucLoFrequencyInput' ) ;
      if ( anElement )
      {
         if (anFskComms)
            anElement.disabled = true;
         else
            anElement.disabled = false;
      }
   }
}

function asyncUpdateXmitBucOutputEnableStatus(anOutputEnable)
{
   var anElement = Get_Iframe_Element( 'TxBucOutputEnableSelect' ) ;
   if ( anElement )
   {
      anElement.value = anOutputEnable;
      if ( bUseFskMenus )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateXmitBucAddressStatus(anAddress)
{
   var anElement = Get_Iframe_Element( 'TxBucAddressInput' ) ;
   if ( anElement )
   {   
      anElement.value = anAddress;
      if ( bUseFskMenus )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateXmitBucFskTestStatus(anFskTest)
{
   var anElement = Get_Iframe_Element( 'TxBucFskTestSelect' ) ;
   if ( anElement )
   {  
      anElement.value = anFskTest;
      if ( bUseFskMenus )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateXmitBucFskTestStatusStatus(anFskTestStatus)
{
   var anElement = Get_Iframe_Element( 'TxBucFskTestStatusSelect' ) ;
   if ( anElement )
      anElement.value = anFskTestStatus;
}

function asyncUpdateXmitBucFskPassThroughCommandStatus(anFskPassThroughCommand)
{
   var anElement = Get_Iframe_Element( 'TxBucFskPassThroughCommandInput' ) ;
   if ( anElement )
      anElement.value = anFskPassThroughCommand;
   {   
      if ( bUseFskMenus )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateXmitBucFskPassThroughResponseStatus(anFskPassThroughResponse)
{
   var anElement = Get_Iframe_Element( 'TxBucFskPassThroughResponseInput' ) ;
   if ( anElement )
      anElement.value = anFskPassThroughResponse;
}

// ****************************************************************** 
// * Functions to update the select content.
// ******************************************************************

function asyncUpdateXmitBucOscSideBandSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucOscSideBandSelect', aSelectContent );
}

function asyncUpdateXmitBucReferenceEnableSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucReferenceEnableSelect', aSelectContent );
}

function asyncUpdateXmitBucSupplyVoltageEnableSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucSupplyVoltageEnableSelect', aSelectContent );
}

function asyncUpdateXmitBucFskCommsSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucFskCommsSelect', aSelectContent );
}

function asyncUpdateXmitBucOutputEnableSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucOutputEnableSelect', aSelectContent );
}

function asyncUpdateXmitBucFskTestSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucFskTestSelect', aSelectContent );
}

function asyncUpdateXmitBucFskTestStatusSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxBucFskTestStatusSelect', aSelectContent );
}

